import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "ScrollingCombatText.Utils.Settings";

	_G.pluginName = "Scrolling Combat Text";
	_G.version = "0.2.3";
	_G.author = "Mirendir";

	_G.sct_width = 600;
	_G.sct_height = 600;
	
local maxmsg=20;
local maxlbl=20;

local debug=false;

local arr_sct = {};
local arr_queue = {};

local screen_height = 0;
local screen_width = 0;

local msg_height = 30;

-- values
local val_max = 1000;
local val_min = 0;
local val_low = 50;

local arr_labels = {};
local label_idx = 0;

-- future plans
local arr_speed = { 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0 , 0 , 1, 0 , 1, 0 , 1, 0, 1, 0, 1, 0 , 2, 1, 2, 1, 2, 1, 2, 2, 3, 4, 5 };

-- Load Settings
	Settings_Load();

	-- options
	sctCommand = Turbine.ShellCommand();
	Turbine.Shell.AddCommand("sct", sctCommand);
	
	function sctCommand:GetShortHelp()
	    return L["usage: /sct options"];
	end
	
	function sctCommand:GetHelp()
	    return self:GetShortHelp();
	end

function sctCommand:Execute(cmd, args)
    if (args == L["options"] or args == "options") then
     	--	Turbine.PluginManager:ShowOptions() 					-- still crashes the client
      
     else
        Turbine.Shell.WriteLine(self:GetShortHelp());
    end
end

	screen_width = Turbine.UI.Display:GetWidth();
	screen_height = Turbine.UI.Display:GetHeight();
	sct_height = screen_height - ( sct_cfg.margin_top + sct_cfg.margin_bottom );
	
	-- Main SCT Window
	myWindow = Turbine.UI.Window();
	myWindow:SetPosition( ((screen_width - sct_width) / 2), ((screen_height - sct_height) / 2) );
	myWindow:SetSize( sct_width, sct_height );
   myWindow:SetVisible(true);
   if (debug) then
		myWindow:SetBackColor( Turbine.UI.Color( 0.3, 0.1, 0.1, 0.1 ) );
	else
		myWindow:SetBackColor( Turbine.UI.Color( 0.01, 0.0, 0.0, 0.0 ) );  -- no fading possible if transparent
	end
	myWindow:SetWantsUpdates(true);
	myWindow:SetOpacity ( 1.0);
	myWindow:SetZOrder (-255);
	myWindow:SetEnabled (false);
	myWindow:SetMouseVisible(false);
	
	-- Debug SCT Window
	if (debug) then
		win_debug = Turbine.UI.Window();
		win_debug:SetPosition( 200, 400 );
		win_debug:SetSize( 400, 400 );
	   win_debug:SetVisible(true);
		win_debug:SetBackColor( Turbine.UI.Color( 0.2, 0.1, 0.1, 0.1 ) );
		win_debug:SetOpacity ( 1.0);
		win_debug:SetZOrder (-255);
	
		-- debug info
		lbl_debug = Turbine.UI.Label();
	   lbl_debug:SetParent( win_debug );
	   lbl_debug:SetSize( 400, 400 );
		lbl_debug:SetBackColor( Turbine.UI.Color( dmg_colb_a, dmg_colb_r, dmg_colb_g, dmg_colb_b ) );
	   lbl_debug:SetForeColor( Turbine.UI.Color( 1.0, 1.0, 1.0) );
	   lbl_debug:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		lbl_debug:SetOpacity (1.0);
		win_debug:SetZOrder (-255);
	end
	
	arr_font = {};
	arr_font[1]=(Turbine.UI.Lotro.Font.TrajanPro13);
	arr_font[2]=(Turbine.UI.Lotro.Font.TrajanPro14);
	arr_font[2]=(Turbine.UI.Lotro.Font.TrajanPro15);
	arr_font[3]=(Turbine.UI.Lotro.Font.TrajanPro16);
	arr_font[4]=(Turbine.UI.Lotro.Font.TrajanPro18);
	arr_font[5]=(Turbine.UI.Lotro.Font.TrajanPro19);
	arr_font[6]=(Turbine.UI.Lotro.Font.TrajanPro20);
	arr_font[7]=(Turbine.UI.Lotro.Font.TrajanPro21);
	arr_font[8]=(Turbine.UI.Lotro.Font.TrajanPro23);
	arr_font[9]=(Turbine.UI.Lotro.Font.TrajanPro24);
	arr_font[10]=(Turbine.UI.Lotro.Font.TrajanPro26);
	arr_font[11]=(Turbine.UI.Lotro.Font.TrajanPro28);	
	
	arr_size = { 15, 16, 17, 19, 21, 22, 23, 25, 26, 27, 29 };
	
	-- create labels
	for i=1,maxlbl,1 do
		arr_labels[i] = Turbine.UI.Label();
		actlabel = arr_labels[i];
   	actlabel:SetParent( myWindow );
	   actlabel:SetSize( sct_width-20, 14 );
		actlabel:SetBackColor( Turbine.UI.Color( 0.0, 0.4, 0.4, 0.4 ) );
	   actlabel:SetForeColor( Turbine.UI.Color( 0.0, sct_cfg.col_dmgn_r / 256 , sct_cfg.col_dmgn_g / 256 , sct_cfg.col_dmgn_b / 256) );
	   actlabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		actlabel:SetOpacity (0.5);
		actlabel:SetVisible(false);
		actlabel:SetFont (Turbine.UI.Lotro.Font.TrajanPro13);
		actlabel:SetPosition( sct_width / 2, sct_height / 2 + i * 14 );		
		actlabel:SetOutlineColor ( Turbine.UI.Color( 0.4, 0.0, 0.0, 0.0 ) );
		actlabel:SetBackColorBlendMode (Turbine.UI.BlendMode.AlphaBlend);
	end
	
	Turbine.Shell.WriteLine(pluginName .." V " .. version );

	-- welcome message
	local arr_val = {};
	local arr_msg = {};
	
	arr_val.utype = 99;
	arr_val.skill = pluginName;
	arr_val.dmg = version;
	
	arr_msg.val = val_max; -- set to max val
	arr_msg.lbl = 1;
	arr_msg.msg = arr_val ;
	
	-- insert message in sct table, check for overflow
	table.insert (arr_sct, arr_msg);

	
function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

-- Main Loop
function myWindow.Update()

	local timestamp = Turbine.Engine.GetGameTime();	
	local val = 0;
	local dmg = 0;
	local skill = "";
	local utype = 0;
	local label = 0;
	local arr_del = {};
	local trans = 100;
	local text = "";
	local font = 1;
	local wait = false;
	
	-- new queing
	hval = 0;
	for i=1, #arr_sct, 1 do
		val = arr_sct[i].val;
		if (val >= hval) then hval = val; end
		
	end
	
	if (hval < val_max - 80) then
		object = arr_queue[1];
		table.insert (arr_sct, object);
		table.remove (arr_queue,1);
	end
	
	-- main drawing loop
	if (#arr_sct > 0) then
		for i=1, #arr_sct, 1 do
	
			val = arr_sct[i].val;
			utype = arr_sct[i].msg.utype;
			
			-- check only for dmg, heal + power events
			if (val > val_min and utype <5 or utype == 99) then
			
				dmg = arr_sct[i].msg.dmg;
				skill = arr_sct[i].msg.skill;
				label = arr_sct[i].lbl;
				sender = arr_sct[i].msg.sender;
				crit = arr_sct[i].msg.crit;

				if (sender ~= player.name) then
					text = tostring(sender) ..": "..tostring(dmg).. "  " .. tostring(skill) .."  ";
				else
					text = tostring(dmg).. "  " .. tostring(skill) .."  ";
				end
					
				if (debug) then				
					text = "v("..tostring(val)..") " .. text;
				end

			-- first deal with general flags
			
				-- fade
				if (sct_cfg.fade) then
					trans = round( val / 10) ;
					if (trans > 100) then trans = 100; end
				else
					trans = 100;
				end	
				
				if (dmg == 0) then trans = 0; end
				
				-- outline
				if (sct_cfg.outline) then	   
					arr_labels[label]:SetFontStyle (Turbine.UI.FontStyle.Outline);
					-- outline_alpha
					arr_labels[label]:SetOutlineColor ( Turbine.UI.Color( 0.01 * sct_cfg.outline_alpha, 0.1, 0.1, 0.1 ) );
				else
					arr_labels[label]:SetFontStyle (Turbine.UI.FontStyle.None);
				end
	

				--arr_labels[label]:SetOutlineColor ( Turbine.UI.Color(  0.1, 0.1, 0.1 ) );
				
				-- zoom & size
				if (sct_cfg.zoom) then 
					font = round( val / 100); 
				else 
					font=sct_cfg.fontsize; 
				end
				

	
				-- place me in screen middle
				screen_width = Turbine.UI.Display:GetWidth();
				screen_height = Turbine.UI.Display:GetHeight();
				
				--sct_width = 600;
				sct_height = screen_height - ( sct_cfg.margin_top + sct_cfg.margin_bottom );
				myWindow:SetSize( sct_width, sct_height );
				myWindow:SetPosition( ((screen_width - sct_width) / 2) - (500 - sct_cfg.center), sct_cfg.margin_top );
				
				scroll_up_start_x = 0;
				scroll_up_start_y = sct_height / 2 - sct_cfg.margin_mid;
				scroll_down_start_x = 0;
				scroll_down_start_y = sct_height / 2 + sct_cfg.margin_mid;	
				scroll_size_y = sct_height / 2 - sct_cfg.margin_mid- 40;
				-- scroll value			
				scroll_y = 	scroll_size_y - (scroll_size_y * val / val_max);		
								
								
				-- now event type actions
				if (utype == 1) then
								
					if (crit == 2) then
						-- DMG CRIT
						arr_labels[label]:SetForeColor( Turbine.UI.Color( trans * 0.01, sct_cfg.col_dmgc_r / 256, sct_cfg.col_dmgc_g / 256 , sct_cfg.col_dmgc_b / 256) );
						if (sct_cfg.dir_dmgc==1) then
							-- up 
							arr_labels[label]:SetPosition( scroll_up_start_x, scroll_up_start_y - scroll_y ); 
						else
							-- down
							arr_labels[label]:SetPosition( scroll_down_start_x, scroll_down_start_y + scroll_y ); 
						end
					end
					
					if (crit==3) then
						-- DMG DEVASTATED
						arr_labels[label]:SetForeColor( Turbine.UI.Color( trans * 0.01, sct_cfg.col_dmgd_r / 256, sct_cfg.col_dmgd_g / 256 , sct_cfg.col_dmgd_b / 256) );
						font=11;
						if (sct_cfg.dir_dmgd==1) then
							-- up 
							arr_labels[label]:SetPosition( scroll_up_start_x, scroll_up_start_y - (scroll_y / 2) ); 
						else
							-- down
							arr_labels[label]:SetPosition( scroll_down_start_x, scroll_down_start_y + (scroll_y /2) ); 
						end
					end
					
					if (crit==0) then
					-- DMG NORMAL
						arr_labels[label]:SetForeColor( Turbine.UI.Color( trans * 0.01, sct_cfg.col_dmgn_r / 256, sct_cfg.col_dmgn_g / 256 , sct_cfg.col_dmgn_b / 256) );
						if (sct_cfg.dir_dmgn==1) then
							-- up 
							arr_labels[label]:SetPosition( scroll_up_start_x, scroll_up_start_y - scroll_y );
						else
							-- down
							arr_labels[label]:SetPosition( scroll_down_start_x, scroll_down_start_y + scroll_y ); 
						end
					end
					
				end
				
				-- TAKEN
				if (utype==2) then
					if (sct_cfg.dir_takn==1) then
						-- up 
						arr_labels[label]:SetPosition( scroll_up_start_x, scroll_up_start_y - scroll_y );
					else
						-- down
						arr_labels[label]:SetPosition( scroll_down_start_x, scroll_down_start_y + scroll_y ); 
					end
					arr_labels[label]:SetForeColor( Turbine.UI.Color( trans * 0.01, sct_cfg.col_takn_r / 256, sct_cfg.col_takn_g / 256 , sct_cfg.col_takn_b / 256) );
					text = tostring(dmg).. "  " .. tostring(skill) .."  ("..tostring(sender)..")";
				end
				
				-- HEAL
				if (utype==3) then
					if (sct_cfg.dir_heal==1) then
						-- up 
						arr_labels[label]:SetPosition( scroll_up_start_x, scroll_up_start_y - scroll_y );
					else
						-- down
						arr_labels[label]:SetPosition( scroll_down_start_x, scroll_down_start_y + scroll_y ); 
					end
					arr_labels[label]:SetForeColor( Turbine.UI.Color( trans * 0.01, sct_cfg.col_heal_r / 256, sct_cfg.col_heal_g / 256 , sct_cfg.col_heal_b / 256) );
					text = tostring(sender) .. ": ".. tostring(dmg).. " " .. tostring(skill) .."  ";
				end

				-- POWER
				if (utype==4) then
					if (sct_cfg.dir_powr==1) then
						-- up 
						arr_labels[label]:SetPosition( scroll_up_start_x, scroll_up_start_y - scroll_y );
					else
						-- down
						arr_labels[label]:SetPosition( scroll_down_start_x, scroll_down_start_y + scroll_y ); 
					end
					arr_labels[label]:SetForeColor( Turbine.UI.Color( trans * 0.01, sct_cfg.col_powr_r / 256, sct_cfg.col_powr_g / 256 , sct_cfg.col_powr_b / 256) );
					text = tostring(sender) .. ": ".. tostring(dmg).. " " .. tostring(skill) .."  ";
				end

				-- TEXT
				if (utype==99) then
					arr_labels[label]:SetPosition( scroll_up_start_x, scroll_up_start_y - scroll_y );
					arr_labels[label]:SetForeColor( Turbine.UI.Color( trans * 0.01, sct_cfg.col_heal_r / 256, sct_cfg.col_heal_g / 256 , sct_cfg.col_heal_b / 256) );
					text = tostring(skill) .."  "..tostring(dmg);
				end
				
				arr_labels[label]:SetFont (arr_font[font]);
				arr_labels[label]:SetHeight (arr_size[font]);
				
				-- set text and make it visible
				if (trans > 0) then
					arr_labels[label]:SetText(text);
					arr_labels[label]:SetVisible(true);
				end
				
				-- new speed
				val = val - sct_cfg.speed;
				arr_sct[i].val=val;
				
				if (val < val_low) then
					table.insert (arr_del,i);
					arr_sct[i].val=0;
				end 			
			
			else
				table.insert (arr_del,i);
			end -- val >0	
						
		
		end -- for loop


	end -- #arr_sct >0
	
	
	-- Debug
	if (debug) then
		local txt_debug = "";
		
		--curtime = Turbine.Engine.GetGameTime();
		txt_debug = ("DEBUG: msgs(" .. #arr_sct .. ") ");
		if (#arr_sct > 0) then
		
			for i=1,#arr_sct, 1 do
				txt_debug = txt_debug .. "\n" .. "v: " ..tostring(arr_sct[i].val) .. " l: " ..tostring(arr_sct[i].lbl) .. " s: " ..tostring(arr_sct[i].msg.skill); 
			end
		end	
		txt_debug = txt_debug .. "\nfade: "..tostring(sct_cfg.fade) .. " ol: "..tostring(sct_cfg.outline).." zoom: "..tostring(sct_cfg.zoom) ;
			
		txt_debug = txt_debug .. "\nscroll_size_y: "..tostring(scroll_size_y) .. " sct_height: "..tostring(sct_height) .. " diff "..tostring(diff);
		txt_debug = txt_debug .. "\ncenter: "..tostring(sct_cfg.center);
		lbl_debug:SetText (txt_debug); 
		
	end 
	
	-- cleaning up
	if (#arr_del > 0) then
		for i=1,#arr_del, 1 do
			-- first get label
			if (arr_sct[i] ~= nil) then
				label = arr_sct[i].lbl;
				arr_labels[label]:SetVisible(false);
			end	
			table.remove (arr_sct,arr_del[i]); 
		end
	end
		
	if (#arr_sct > maxmsg) then 
		table.remove (arr_sct, 1);
	end
end

-- add callback event
function f_AddCallback(object, event, callback)
	if (object[event] == nil) then
		object[event] = callback;
	else
		if (type(object[event]) == "table") then
			table.insert(object[event], callback);
		else
			object[event] = {object[event], callback};
		end
	end
end


--
--For reference: the updateType enum
-- 1 = dmg dealt
-- 2 = dmg taken
-- 3 = heal
-- 4 = power restore
-- 5 = debuff applied
-- 6 = buff applied
-- 7 = interrupt
-- 8 = corruption
-- 9 = death
-- 10 = revive
-- 11 = combat start
-- 12 = combat end
 -- 13 = and we highjacked 13 for mob interrupts (opposite of player interrupts)
--

f_AddCallback(Turbine.Chat,"Received",function(sender, args)
	
	local timestamp = Turbine.Engine.GetGameTime();
	local arr_val = {};
	local crit = 0;
	local arr_msg = {};
	
	--label:SetText (args.Message);
	-- only parse combat text
	if ((args.ChatType ~= Turbine.ChatType.PlayerCombat) and (args.ChatType ~= Turbine.ChatType.EnemyCombat)) then
		return;
	end
	
	-- grab line from combat log, strip it of color, trim it, and parse it according to the localized parsing function
	local updateType,initiatorName,targetName,skillName,var1,var2,var3,var4 = L.Parse(string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"));
		
	if (updateType == nil ) then return end
	
	if (updateType == 1 or updateType == 7) then
			if (targetName == player.name) then
				updateType = 2;
			end
	end
	
			
	--arr_val = {type=updateType, source=initiatorName,target=targetName,skill=skillName,dmg=var1,var2=var2,var3=var3,var4=var4};
	if (updateType < 3) then
		if (var3 > 1) then crit=var3; end
	end
	arr_val.dmg = var1;
	arr_val.utype = updateType;
	arr_val.skill = skillName;
	arr_val.crit = crit; 
	arr_val.sender = initiatorName;

	-- label management
	label_idx = label_idx+1;
	if (label_idx > maxlbl ) then 
		label_idx = 1;
	end;

	arr_msg.val = val_max; -- set to max val
	arr_msg.lbl = label_idx;
	arr_msg.msg = arr_val ;

	-- insert message in sct table, check for overflow
	table.insert (arr_queue, arr_msg);


	-- DEBUG
	if (debug) then
			Turbine.Shell.WriteLine ("t: ".. tostring(updateType) .. " s: "..tostring(skillName).." d: "..tostring(var1) .. " i: " .. initiatorName);
	end
	
	
end );