import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "ScrollingCombatText.Utils.Class";


local fnt_title = Turbine.UI.Lotro.Font.TrajanPro16;
local fnt_options = Turbine.UI.Lotro.Font.TrajanPro14;

local locplayer = Turbine.Gameplay.LocalPlayer:GetInstance();
	_G.player = {};
	player.name = locplayer:GetName(); 

-- sct_cfg = array of config values
	_G.sct_cfg = {};
	_G.sct_opt = {};
	
-- sct_opt = array of option ui elements	
	_G.optpanel = false;
	
-- get locale
	_G.lang = "en";

	if Turbine.Shell.IsCommand("hilfe") then
		lang = "de";
	elseif Turbine.Shell.IsCommand("aide") then
		lang = "fr";
	end
	
	_G.euroFormat = (tonumber("1,000")==1);
	
--import langfiles
	pcall(import, ("ScrollingCombatText.Locale.%s"):format(lang));
	pcall(import, ("ScrollingCombatText.Locale.parser_%s"):format(lang));

function _G.Settings_Load()

	loaded = Turbine.PluginData.Load (Turbine.DataScope.Character, "ScrollingCombatText");  
	_G.sct_cfg = Decode(loaded);
			 
	if (type(sct_cfg) ~= "table") then
        -- set defaults
        Turbine.Shell.WriteLine ("no settings found...");
        Settings_Defaults();
        Settings_Save();
   else
	
		--for i,v in pairs(loaded) do
		--	sct_cfg[i] = v;
		--end

		-- check if all values set
		if (sct_cfg.version ==nil) then
		 		
			Settings_Defaults();
			Settings_Save();
		end
		
		if (sct_cfg.version ~= version) then
			
		 	if (sct_cfg.version == "0.1.7") then
		 		Turbine.Shell.WriteLine ("updating settings...to V 0.2.1");
				sct_cfg.outline_alpha = 100;
				sct_cfg.version = "0.2.1";
				Settings_Save();
		 	end
		 	
		 	if (sct_cfg.version == "0.2.1" or sct_cfg.version == "0.2.2" ) then
		 		Turbine.Shell.WriteLine ("updating settings...to V 0.2.3");
				sct_cfg.col_dmgd_r = 255;
				sct_cfg.col_dmgd_g = 67;
				sct_cfg.col_dmgd_b = 167;
				sct_cfg.dir_dmgd = 1;
				sct_cfg.version = "0.2.3";
				Settings_Save();
		 	end
		end
		
	end
	-- now call Optionpanel
	

	Options();
			
end	

function _G.Settings_Save()
	
	--table.sort (sct_cfg);
   savedata = Encode(sct_cfg);

	Turbine.PluginData.Save (Turbine.DataScope.Character,"ScrollingCombatText", savedata);
	Turbine.Shell.WriteLine(L["Settings_saved"]);
end

function _G.Encode(object)
    if ("en" == Turbine.Engine.GetLocale()) then
        return object;
    end

    local lookup_table = {};
    local function _encode(object)
        if (type(object) == "number") then
            return ("<num>%f</num>"):format(object);
        elseif (type(object) ~= "table") then
            return object;
        elseif (lookup_table[object]) then
            return lookup_table[object];
        end
        local new_table = {};
        lookup_table[object] = new_table;
        for index, value in pairs(object) do
            new_table[_encode(index)] = _encode(value);
        end
        return setmetatable(new_table, getmetatable(object));
    end
    return _encode(object);
end


function _G.Decode(object)
    if ("en" == Turbine.Engine.GetLocale()) then
        return object;
    end
    
    local lookup_table = {};
    local function _decode(object)
        if (type(object) == "string") then
          
			local match = object:match("<num>(-?%d+[.,]%d+)</num>");
				if (match ~= nil) then
					return tonumber(match);
				else
					return object;
				end
        elseif (type(object) ~= "table") then
            return object;
        elseif lookup_table[object] then
            return lookup_table[object];
        end
        local new_table = {};
        lookup_table[object] = new_table;
        for index, value in pairs(object) do
            new_table[_decode(index)] = _decode(value);
        end
        return setmetatable(new_table, getmetatable(object));
    end
    return _decode(object);
end

function _G.Options()

	-- get optionspanel
	if (optpanel == false) then
		optionsPanel = Turbine.UI.Control();
		optionsPanel:SetBackColor( Turbine.UI.Color( 0.8, 0.00, 0.00, 0.00 ) );
		optionsPanel:SetSize( 280, 560 );
		optpanel = true;
		
		plugin.GetOptionsPanel = function( self )
		  return optionsPanel;
		end
	else

end

		
-- Abbreviations
-- dmgn = damage
-- dmgc = dmg crit
-- heal = heal
-- powr = power
-- takn = taken dmg
-- _r	  = red
-- _g   = green
-- _b   = blue
-- sld  = slider
-- lbl  = label
-- btn  = button
-- win  = window
-- chk  = checkbox
-- sel  = select = listbox

	myListBox = class (Turbine.UI.Control)
	function myListBox:Constructor (dir)
		
		Turbine.UI.Control.Constructor (self);
		
		self.item_heigth = 16;
		self.width = 80;
		self.active = false;
		self.selected = sct_cfg[dir];
		self:SetSize( self.width, self.item_heigth);
		self:SetBackColor (Turbine.UI.Color (1.0 ,0.2, 0.2, 0.2));

		self.items = {};
		self.itemlabels = {};
		self.box = Turbine.UI.Control();
		self.box:SetParent (self);
		self.box:SetSize (80,  self.item_heigth);
				
		self.text = Turbine.UI.Label();
		self.text:SetParent (self.box);
		self.text:SetSize (60, 12);
		self.text:SetPosition ( 0, 0);
		self.text:SetFont(Turbine.UI.Lotro.Font.TrajanPro13);
		self.text:SetFontStyle(Turbine.UI.FontStyle.None );
		self.text:SetForeColor(Turbine.UI.Color(1.0, 0.9, 0.9, 0.9));
				
		self.button = Turbine.UI.Button();
		self.button:SetSize (12,self.item_heigth);
		self.button:SetPosition ( 80-12, 0);
		self.button:SetParent (self);
		self.button:SetBackColor (Turbine.UI.Color (1.0, 0.0, 0.0, 0,0));
		self.button:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		self.button:SetText ("v");
		
		self.list = Turbine.UI.ListBox();
		self.list:SetSize (self.width-12,self.item_heigth);
		self.list:SetPosition ( 0, self.item_heigth);
		self.list:SetParent (self);	
		self.list:SetOrientation (Turbine.UI.Orientation.Vertical);
		self.list:SetBackColor( Turbine.UI.Color( 0.8, 0.0, 0.0, 0.0) );	
		self.list:SetVisible (self.active);
				
		self.Name = function (text)
			self.text:SetText (text);
		end

		self.Additem = function (text)
			table.insert (self.items, text)
			
			local label = Turbine.UI.Label();
			label:SetSize( 60,  self.item_heigth );
			label:SetText (text);
			--label:SetBackground ( "ScrollingCombatText/Resources/listitem.tga");
			self.list:AddItem( label );
			self.list:SetSize (self.width, self.item_heigth * #self.items);
		end
		
		self.button.MouseClick = function (sender,args)
			if (self.active) then 
				self:SetSize (self.width, self.item_heigth);
				self.list:SetSize (0, 0);
				self.list:SetVisible (false);
				self.active= false; 
			else 
				self.active=true;
				self:SetSize (self.width, self.item_heigth * ( #self.items + 1));
				self.list:SetSize (self.width, self.item_heigth * ( #self.items));
				self.list:SetVisible(true); 
			end
		end
		
		self.text.MouseClick = function (sender,args)
			if (self.active) then 
				self:SetSize (self.width, self.item_heigth);
				self.list:SetSize (0, 0);
				self.list:SetVisible (false);
				self.active= false; 
			else 
				self.active=true;
				self:SetSize (self.width, self.item_heigth * ( #self.items + 1));
				self.list:SetSize (self.width, self.item_heigth * ( #self.items));
				self.list:SetVisible(true); 
			end
		end
		
		self.list.SelectedIndexChanged = function ()
			self.selected = self.list:GetSelectedIndex();
			if (debug) then Turbine.Shell.WriteLine ("p: "..self.selected.. " t: "..self.items[self.selected]); end
			self:SetSize (self.width, self.item_heigth);
			self.list:SetSize (0, 0);
			self.list:SetVisible (false);
			self.active=false; 
			self.text:SetText(self.items[self.selected]);
			sct_cfg[dir]=self.selected;
		end

		self.Update = function ()
			self.text:SetText (self.items[self.selected]);
		end
		
	end -- class
	
	
-- class ColorPicker
	myColorPicker = class (Turbine.UI.Control);
	function myColorPicker:Constructor (r,g,b)
		
		Turbine.UI.Control.Constructor (self);
		
		self.button_w = 90;
	   self.button_h = 30;
		self.button = Turbine.UI.Button();
		self.button:SetSize( self.button_w, self.button_h );
		self.button:SetPosition( 8, 0 );
		self.button:SetParent( self );	
		self.button:SetText("("..tostring(sct_cfg[r])..","..tostring(sct_cfg[g])..","..tostring(sct_cfg[b])..")");
		if ( ( (sct_cfg[r]) + sct_cfg[g] +  sct_cfg[b]) > 400 ) then
			self.button:SetForeColor ( Turbine.UI.Color (0.1, 0.1, 0.1) );
		else
			self.button:SetForeColor ( Turbine.UI.Color (1.0, 1.0, 1.0) );
		end
		self.button:SetBackColor( Turbine.UI.Color(	sct_cfg[r] / 256, sct_cfg[g] / 256, sct_cfg[b] / 256) );

		self.sld_r = Turbine.UI.Lotro.ScrollBar();
		self.sld_r:SetSize( 100, 10 );
		self.sld_r:SetPosition( 100, 0 );	
		self.sld_r:SetParent( self );	
		self.sld_r:SetMinimum( 0 );	
		self.sld_r:SetMaximum( 255 );	
		self.sld_r:SetValue (sct_cfg[r] );
		self.sld_r:SetOrientation (Turbine.UI.Orientation.Horizontal);

		self.sld_g = Turbine.UI.Lotro.ScrollBar();
		self.sld_g:SetSize( 100, 10 );
		self.sld_g:SetPosition( 100, 10 );	
		self.sld_g:SetParent( self );	
		self.sld_g:SetMinimum( 0 );	
		self.sld_g:SetMaximum( 255 );	
		self.sld_g:SetValue ( sct_cfg[g] );
		self.sld_g:SetOrientation (Turbine.UI.Orientation.Horizontal);
				
		self.sld_b = Turbine.UI.Lotro.ScrollBar();
		self.sld_b:SetSize( 100, 10 );
		self.sld_b:SetPosition( 100, 20 );	
		self.sld_b:SetParent( self );	
		self.sld_b:SetMinimum( 0 );	
		self.sld_b:SetMaximum( 255 );	
		self.sld_b:SetValue ( sct_cfg[b] );
		self.sld_b:SetOrientation (Turbine.UI.Orientation.Horizontal);
					
		self.lbl_r = Turbine.UI.Label();
		self.lbl_r:SetSize ( 60, 20);
		self.lbl_r:SetPosition( 218, 0 );		
		self.lbl_r:SetParent( self );	
		self.lbl_r:SetVisible(true);
		self.lbl_r:SetForeColor( Turbine.UI.Color( 1.0, 0.0, 0.0 ));
		self.lbl_r:SetText ("r: ".. sct_cfg[r]);
		
		self.lbl_g = Turbine.UI.Label();
		self.lbl_g:SetSize ( 60, 20);
		self.lbl_g:SetPosition( 218, 10 );		
		self.lbl_g:SetParent( self );	
		self.lbl_g:SetVisible(true);
		self.lbl_g:SetForeColor( Turbine.UI.Color( 0.0, 1.0, 0.0 ));
		self.lbl_g:SetText ("g: ".. sct_cfg[g]);
		
		self.lbl_b = Turbine.UI.Label();
		self.lbl_b:SetSize ( 60, 20);
		self.lbl_b:SetPosition( 218, 20 );		
		self.lbl_b:SetParent( self );	
		self.lbl_b:SetVisible(true);
		self.lbl_b:SetForeColor( Turbine.UI.Color( 0.0, 0.0, 1.0 ));
		self.lbl_b:SetText ("b: ".. sct_cfg[b]);
				
		self.sld_r.ValueChanged = function ()
		sct_cfg[r] = self.sld_r:GetValue();
		sct_cfg[g] = self.sld_g:GetValue();
		sct_cfg[b] = self.sld_b:GetValue();
		self.lbl_r:SetText ("r: ".. sct_cfg[r]);
		self.button:SetText("("..sct_cfg[r]..","..sct_cfg[g]..","..sct_cfg[b]..")");
		self.button:SetBackColor( Turbine.UI.Color( sct_cfg[r] / 256, sct_cfg[g] / 256, sct_cfg[b] / 256) );
			if ( (sct_cfg[r] + sct_cfg[g] +  sct_cfg[b]) > 400 ) then
				self.button:SetForeColor ( Turbine.UI.Color (0.1,0.1, 0.1) );
			else
				self.button:SetForeColor ( Turbine.UI.Color (1.0,1.0, 1.0) );
			end
		end

		self.sld_g.ValueChanged = function ()
		sct_cfg[r] = self.sld_r:GetValue();
		sct_cfg[g] = self.sld_g:GetValue();
		sct_cfg[b] = self.sld_b:GetValue();
		self.lbl_g:SetText ("g: ".. sct_cfg[g]);
		self.button:SetText("("..sct_cfg[r]..","..sct_cfg[g]..","..sct_cfg[b]..")");
		self.button:SetBackColor( Turbine.UI.Color( sct_cfg[r] / 256, sct_cfg[g] / 256, sct_cfg[b] / 256) );
			if ( (sct_cfg[r] + sct_cfg[g] +  sct_cfg[b]) > 400 ) then
				self.button:SetForeColor ( Turbine.UI.Color (0.1,0.1, 0.1) );
			else
				self.button:SetForeColor ( Turbine.UI.Color (1.0,1.0, 1.0) );
			end
		end

		self.sld_b.ValueChanged = function ()
		sct_cfg[r] = self.sld_r:GetValue();
		sct_cfg[g] = self.sld_g:GetValue();
		sct_cfg[b] = self.sld_b:GetValue();
		self.lbl_b:SetText ("b: ".. sct_cfg[b]);
		self.button:SetText("("..sct_cfg[r]..","..sct_cfg[g]..","..sct_cfg[b]..")");
		self.button:SetBackColor( Turbine.UI.Color( sct_cfg[r] / 256, sct_cfg[g] / 256, sct_cfg[b] / 256) );
			if ( (sct_cfg[r] + sct_cfg[g] +  sct_cfg[b]) > 400 ) then
				self.button:SetForeColor ( Turbine.UI.Color (0.1,0.1, 0.1) );
			else
				self.button:SetForeColor ( Turbine.UI.Color (1.0,1.0, 1.0) );
			end
		end

end
-- end class


-- Option Layout
	local coloffset = 22;
	local rows = {};
	
	rows[1] = 0;	-- dmg
	rows[2] = 60;  -- crit
	rows[3] = 120; -- devastated
	rows[4] = 180;	-- taken
	rows[5] = 240; -- heal	
	rows[6] = 300; -- power
	--
	rows[7] = 360;
	rows[8] = 374;	
	rows[9] = 388;
	rows[10] = 402;
	rows[11] = 416;
	rows[12] = 430;
	rows[13] = 444;
	rows[14] = 464;
	rows[15] = 490;
	rows[16] = 510;	
	
	local col_title_back = ( Turbine.UI.Color( 0.8, 0.1, 0.1, 0.1) )
	local pos_drop_x = 190;
	local title_height = 18;
	
	row = 1;
	
-- Damage Normal
	local lbl_dmgn	= Turbine.UI.Label();
	lbl_dmgn:SetSize( 260, title_height );
	lbl_dmgn:SetPosition( 10, rows[row] );
	lbl_dmgn:SetParent( optionsPanel );	
	lbl_dmgn:SetBackColor( col_title_back );
	lbl_dmgn:SetText (L["Own_Damage_Normal"]);
	lbl_dmgn:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
	lbl_dmgn:SetFont (fnt_title);
	table.insert (sct_opt, lbl_dmgn);
		
	-- DropDownMenu
	local sel_dmgn_dir = myListBox ("dir_dmgn");
	sel_dmgn_dir:SetParent (optionsPanel);
	sel_dmgn_dir:SetPosition( pos_drop_x, rows[row]);
	sel_dmgn_dir:SetZOrder ( 10);
	sel_dmgn_dir.Additem (L["Up"]); -- 1 = up
	sel_dmgn_dir.Additem (L["Down"]); -- 2 = down
	sel_dmgn_dir.Update ();		
	table.insert (sct_opt, sel_dmgn_dir);
		
	-- Color
	local col_normal = myColorPicker( "col_dmgn_r", "col_dmgn_g", "col_dmgn_b");
	col_normal:SetParent (optionsPanel);
	col_normal:SetSize ( 300, 200);
	col_normal:SetPosition (10, rows[row]+coloffset);
	col_normal:SetZOrder (- 10);
	table.insert (sct_opt, col_normal);
	
	row = row+1;
-- Damage Crit
	local lbl_dmgc	= Turbine.UI.Label();
	lbl_dmgc:SetSize( 260, title_height );
	lbl_dmgc:SetPosition( 10, rows[row] );
	lbl_dmgc:SetParent( optionsPanel );	
	lbl_dmgc:SetBackColor( col_title_back );
	lbl_dmgc:SetText (L["Own_Damage_Crit"]);
	lbl_dmgc:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
	lbl_dmgc:SetFont (fnt_title);
	table.insert (sct_opt, lbl_dmgc);
		
	-- DropDownMenu
	local sel_dmgc_dir = myListBox ("dir_dmgc");
	sel_dmgc_dir:SetParent (optionsPanel);
	sel_dmgc_dir:SetPosition(pos_drop_x, rows[row]);
	sel_dmgc_dir:SetZOrder ( 10);
	sel_dmgc_dir.Additem (L["Up"]); -- 1 = up
	sel_dmgc_dir.Additem (L["Down"]); -- 2 = down
	sel_dmgc_dir.Update ();		
	table.insert (sct_opt, sel_dmgc_dir);
		
	-- Color
	local col_crit = myColorPicker( "col_dmgc_r", "col_dmgc_g", "col_dmgc_b");
	col_crit:SetParent (optionsPanel);
	col_crit:SetSize ( 300, 200);
	col_crit:SetPosition (10, rows[row] + coloffset);
	table.insert (sct_opt, col_crit);

	row = row+1;
-- Damage Devastated
	local lbl_dmgd	= Turbine.UI.Label();
	lbl_dmgd:SetSize( 260, title_height );
	lbl_dmgd:SetPosition( 10, rows[row] );
	lbl_dmgd:SetParent( optionsPanel );	
	lbl_dmgd:SetBackColor( col_title_back );
	lbl_dmgd:SetText (L["Own_Damage_Devastated"]);
	lbl_dmgd:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
	lbl_dmgd:SetFont (fnt_title);
	table.insert (sct_opt, lbl_dmgd);
		
	-- DropDownMenu
	local sel_dmgd_dir = myListBox ("dir_dmgd");
	sel_dmgd_dir:SetParent (optionsPanel);
	sel_dmgd_dir:SetPosition(pos_drop_x,  rows[row]);
	sel_dmgd_dir:SetZOrder ( 10);
	sel_dmgd_dir.Additem (L["Up"]); -- 1 = up
	sel_dmgd_dir.Additem (L["Down"]); -- 2 = down
	sel_dmgd_dir.Update ();		
	table.insert (sct_opt, sel_dmgd_dir);
		
	-- Color
	local col_dev = myColorPicker( "col_dmgd_r", "col_dmgd_g", "col_dmgd_b");
	col_dev:SetParent (optionsPanel);
	col_dev:SetSize ( 300, 200);
	col_dev:SetPosition (10, rows[row] + coloffset);
	table.insert (sct_opt, col_dev);

	row = row+1;
-- Heal
	local lbl_heal	= Turbine.UI.Label();
	lbl_heal:SetSize( 260, title_height );
	lbl_heal:SetPosition( 10, rows[row] );
	lbl_heal:SetParent( optionsPanel );	
	lbl_heal:SetBackColor( col_title_back );
	lbl_heal:SetText (L["Heal"]);
	lbl_heal:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
	lbl_heal:SetFont (fnt_title);
	table.insert (sct_opt, lbl_heal);
	
	-- DropDownMenu
	local sel_heal_dir = myListBox ("dir_heal");
	sel_heal_dir:SetParent (optionsPanel);
	sel_heal_dir:SetPosition(pos_drop_x, rows[row]);
	sel_heal_dir:SetZOrder ( 10);
	sel_heal_dir.Additem (L["Up"]); -- 1 = up
	sel_heal_dir.Additem (L["Down"]); -- 2 = down
	sel_heal_dir.Update ();		
	table.insert (sct_opt, sel_heal_dir);
			
	-- Color
	local col_heal = myColorPicker( "col_heal_r", "col_heal_g", "col_heal_b");
	col_heal:SetParent (optionsPanel);
	col_heal:SetSize ( 300, 200);
	col_heal:SetPosition (10, rows[row] + coloffset);
	table.insert (sct_opt, col_heal);
	
	row = row+1;
-- Power
	local lbl_powr	= Turbine.UI.Label();
	lbl_powr:SetSize( 260, title_height );
	lbl_powr:SetPosition( 10, rows[row] );
	lbl_powr:SetParent( optionsPanel );	
	lbl_powr:SetBackColor( col_title_back );
	lbl_powr:SetText (L["Power"]);
	lbl_powr:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
	lbl_powr:SetFont (fnt_title);
	table.insert (sct_opt, lbl_powr);
		
	-- DropDownMenu
	local sel_powr_dir = myListBox ("dir_powr");
	sel_powr_dir:SetParent (optionsPanel);
	sel_powr_dir:SetPosition(pos_drop_x, rows[row]);
	sel_powr_dir:SetZOrder ( 10);
	sel_powr_dir.Additem (L["Up"]); -- 1 = up
	sel_powr_dir.Additem (L["Down"]); -- 2 = down
	sel_powr_dir.Update ();		
	table.insert (sct_opt, sel_powr_dir);
	
	-- Color
	local col_powr = myColorPicker( "col_powr_r", "col_powr_g", "col_powr_b");
	col_powr:SetParent (optionsPanel);
	col_powr:SetSize ( 300, 200);
	col_powr:SetPosition (10, rows[row] + coloffset);
	table.insert (sct_opt, col_powr);

	row = row+1;
-- Taken
	local lbl_takn	= Turbine.UI.Label();
	lbl_takn:SetSize( 260, title_height );
	lbl_takn:SetPosition( 10, rows[row] );
	lbl_takn:SetParent( optionsPanel );	
	lbl_takn:SetBackColor( col_title_back );
	lbl_takn:SetText (L["Taken_Damage"]);
	lbl_takn:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
	lbl_takn:SetFont (fnt_title);
	table.insert (sct_opt, lbl_takn);
	
	-- DropDownMenu
	local sel_takn_dir = myListBox ("dir_takn");
	sel_takn_dir:SetParent (optionsPanel);
	sel_takn_dir:SetPosition(pos_drop_x, rows[row]);
	sel_takn_dir:SetZOrder ( 10);
	sel_takn_dir.Additem (L["Up"]); -- 1 = up
	sel_takn_dir.Additem (L["Down"]); -- 2 = down
	sel_takn_dir.Update ();		
	table.insert (sct_opt, sel_takn_dir);
	
	-- Color
	local col_takn = myColorPicker( "col_takn_r", "col_takn_g", "col_takn_b");
	col_takn:SetParent (optionsPanel);
	col_takn:SetSize ( 300, 200);
	col_takn:SetPosition (10, rows[row] + coloffset);
	table.insert (sct_opt, col_takn);

	row = row+1;	
-- Speed

	-- speed 
	local lbl_speed = Turbine.UI.Label();
	lbl_speed:SetSize( 100, 10 );
	lbl_speed:SetPosition( 10, rows[row] );	
	lbl_speed:SetParent( optionsPanel );
	lbl_speed:SetText (L["Speed"]);
	table.insert (sct_opt, lbl_speed);
		
	local lbl_speedval = Turbine.UI.Label();
	lbl_speedval:SetSize( 100, 10 );
	lbl_speedval:SetPosition( 214, rows[row] );	
	lbl_speedval:SetParent( optionsPanel );
	lbl_speedval:SetText (tostring(sct_cfg.speed) );
	table.insert (sct_opt, lbl_speedval);	
	
	local sld_speed = Turbine.UI.Lotro.ScrollBar();
	sld_speed:SetSize( 100, 10 );
	sld_speed:SetPosition( 110, rows[row] );	
	sld_speed:SetParent( optionsPanel );	
	sld_speed:SetMinimum( 10 );	
	sld_speed:SetMaximum( 200 );	
	sld_speed:SetSmallChange ( 10 );
	sld_speed:SetValue (sct_cfg.speed * 10 );
	sld_speed:SetOrientation (Turbine.UI.Orientation.Horizontal);
	sld_speed.ValueChanged = function()
		sct_cfg.speed = round (sld_speed:GetValue() / 10) ;
		lbl_speedval:SetText (tostring(sct_cfg.speed) );
	end		
	table.insert (sct_opt, sld_speed);
	
	row = row+1;
-- Margins

	-- top
	local lbl_margin_top = Turbine.UI.Label();
	lbl_margin_top:SetSize( 100, 10 );
	lbl_margin_top:SetPosition( 10, rows[row] );	
	lbl_margin_top:SetParent( optionsPanel );
	lbl_margin_top:SetText (L["Margin_Top"]);
	table.insert (sct_opt, lbl_margin_top);
		
	local lbl_margin_topval = Turbine.UI.Label();
	lbl_margin_topval:SetSize( 100, 10 );
	lbl_margin_topval:SetPosition( 214, rows[row] );	
	lbl_margin_topval:SetParent( optionsPanel );
	lbl_margin_topval:SetText (tostring(sct_cfg.margin_top) .."px");
	table.insert (sct_opt, lbl_margin_topval);
		
	local sld_margin_top = Turbine.UI.Lotro.ScrollBar();
	sld_margin_top:SetSize( 100, 10 );
	sld_margin_top:SetPosition( 110, rows[row] );	
	sld_margin_top:SetParent( optionsPanel );	
	sld_margin_top:SetMinimum( 0 );	
	sld_margin_top:SetMaximum( 200 );	
	sld_margin_top:SetSmallChange ( 1 );
	sld_margin_top:SetValue (sct_cfg.margin_top );
	sld_margin_top:SetOrientation (Turbine.UI.Orientation.Horizontal);
	sld_margin_top.ValueChanged = function()
		sct_cfg.margin_top = sld_margin_top:GetValue() ;
		lbl_margin_topval:SetText (tostring(sct_cfg.margin_top) .."px" );
	end		
	table.insert (sct_opt, sld_margin_top);
	
	row = row+1;
	-- mid
	local lbl_margin_mid = Turbine.UI.Label();
	lbl_margin_mid:SetSize( 100, 10 );
	lbl_margin_mid:SetPosition( 10, rows[row] );	
	lbl_margin_mid:SetParent( optionsPanel );
	lbl_margin_mid:SetText (L["Margin_Mid"]);
	table.insert (sct_opt, lbl_margin_mid);
		
	local lbl_margin_midval = Turbine.UI.Label();
	lbl_margin_midval:SetSize( 100, 10 );
	lbl_margin_midval:SetPosition( 214, rows[row] );	
	lbl_margin_midval:SetParent( optionsPanel );
	lbl_margin_midval:SetText (tostring(sct_cfg.margin_mid) .."px" );
	table.insert (sct_opt, lbl_margin_midval);

	local sld_margin_mid = Turbine.UI.Lotro.ScrollBar();
	sld_margin_mid:SetSize( 100, 10 );
	sld_margin_mid:SetPosition( 110, rows[row] );	
	sld_margin_mid:SetParent( optionsPanel );	
	sld_margin_mid:SetMinimum( 0 );	
	sld_margin_mid:SetMaximum( 200 );	
	sld_margin_mid:SetSmallChange ( 1 );
	sld_margin_mid:SetValue (sct_cfg.margin_mid );
	sld_margin_mid:SetOrientation (Turbine.UI.Orientation.Horizontal);
	sld_margin_mid.ValueChanged = function()
		sct_cfg.margin_mid = sld_margin_mid:GetValue() ;
		lbl_margin_midval:SetText (tostring(sct_cfg.margin_mid) .."px" );
	end		
	table.insert (sct_opt, sld_margin_mid);

	row = row+1;
	-- bottom
	local lbl_margin_bottom = Turbine.UI.Label();
	lbl_margin_bottom:SetSize( 100, 10 );
	lbl_margin_bottom:SetPosition( 10, rows[row] );	
	lbl_margin_bottom:SetParent( optionsPanel );
	lbl_margin_bottom:SetText (L["Margin_Bottom"]);
	table.insert (sct_opt, lbl_margin_bottom);
	
	local lbl_margin_bottomval = Turbine.UI.Label();
	lbl_margin_bottomval:SetSize( 100, 10 );
	lbl_margin_bottomval:SetPosition( 214, rows[row] );	
	lbl_margin_bottomval:SetParent( optionsPanel );
	lbl_margin_bottomval:SetText (tostring(sct_cfg.margin_bottom) .."px" );
	table.insert (sct_opt, lbl_margin_bottomval);
	
	local sld_margin_bottom = Turbine.UI.Lotro.ScrollBar();
	sld_margin_bottom:SetSize( 100, 10 );
	sld_margin_bottom:SetPosition( 110, rows[row] );	
	sld_margin_bottom:SetParent( optionsPanel );	
	sld_margin_bottom:SetMinimum( 0 );	
	sld_margin_bottom:SetMaximum( 200 );	
	sld_margin_bottom:SetSmallChange ( 1 );
	sld_margin_bottom:SetValue (sct_cfg.margin_bottom );
	sld_margin_bottom:SetOrientation (Turbine.UI.Orientation.Horizontal);
	sld_margin_bottom.ValueChanged = function()
		sct_cfg.margin_bottom = sld_margin_bottom:GetValue();
		lbl_margin_bottomval:SetText (tostring(sct_cfg.margin_bottom) .."px" );
	end		
	table.insert (sct_opt, sld_margin_bottom);
	
	row = row+1;
	-- center
	local lbl_center = Turbine.UI.Label();
	lbl_center:SetSize( 100, 10 );
	lbl_center:SetPosition( 10, rows[row] );	
	lbl_center:SetParent( optionsPanel );
	lbl_center:SetText (L["Center"]);
	table.insert (sct_opt, lbl_center);
	
	local lbl_centerval = Turbine.UI.Label();
	lbl_centerval:SetSize( 100, 10 );
	lbl_centerval:SetPosition( 214, rows[row] );	
	lbl_centerval:SetParent( optionsPanel );
	lbl_centerval:SetText (tostring(sct_cfg.center -500) );
	table.insert (sct_opt, lbl_centerval);
	
	local sld_center = Turbine.UI.Lotro.ScrollBar();
	sld_center:SetSize( 100, 10 );
	sld_center:SetPosition( 110, rows[row] );	
	sld_center:SetParent( optionsPanel );	
	sld_center:SetMinimum( 0 );	
	sld_center:SetMaximum( 1000 );	
	sld_center:SetSmallChange ( 1 );
	sld_center:SetValue (sct_cfg.center);
	sld_center:SetOrientation (Turbine.UI.Orientation.Horizontal);
	sld_center.ValueChanged = function()
		sct_cfg.center = sld_center:GetValue();
		lbl_centerval:SetText (tostring(sct_cfg.center) - 500 );
	end
	table.insert (sct_opt, sld_center);
	
	row = row+1;	
	-- fontsize
	local lbl_fontsize = Turbine.UI.Label();
	lbl_fontsize:SetSize( 100, 10 );
	lbl_fontsize:SetPosition( 10, rows[row] );	
	lbl_fontsize:SetParent( optionsPanel );
	lbl_fontsize:SetText (L["Fontsize"]);
	table.insert (sct_opt, lbl_fontsize);
	
	local lbl_fontsizeval = Turbine.UI.Label();
	lbl_fontsizeval:SetSize( 100, 10 );
	lbl_fontsizeval:SetPosition( 214, rows[row] );	
	lbl_fontsizeval:SetParent( optionsPanel );
	lbl_fontsizeval:SetText (tostring(sct_cfg.fontsize) );
	table.insert (sct_opt, lbl_fontsizeval);
	
	local sld_fontsize = Turbine.UI.Lotro.ScrollBar();
	sld_fontsize:SetSize( 100, 10 );
	sld_fontsize:SetPosition( 110, rows[row] );	
	sld_fontsize:SetParent( optionsPanel );	
	sld_fontsize:SetMinimum( 10 );	
	sld_fontsize:SetMaximum( 100 );	
	sld_fontsize:SetSmallChange ( 10 );
	sld_fontsize:SetValue (sct_cfg.fontsize * 10 );
	sld_fontsize:SetOrientation (Turbine.UI.Orientation.Horizontal);
	sld_fontsize.ValueChanged = function()
		sct_cfg.fontsize = round (sld_fontsize:GetValue() / 10);
		lbl_fontsizeval:SetText (tostring(sct_cfg.fontsize));
	end		
	table.insert (sct_opt, sld_fontsize);

	row = row+1;
	-- outline_alpha
	local lbl_outline_alpha = Turbine.UI.Label();
	lbl_outline_alpha:SetSize( 100, 10 );
	lbl_outline_alpha:SetPosition( 10, rows[row] );	
	lbl_outline_alpha:SetParent( optionsPanel );
	lbl_outline_alpha:SetText (L["Outline_Alpha"]);
	table.insert (sct_opt, lbl_outline_alpha);
	
	local lbl_outline_alphaval = Turbine.UI.Label();
	lbl_outline_alphaval:SetSize( 100, 10 );
	lbl_outline_alphaval:SetPosition( 214, rows[row] );	
	lbl_outline_alphaval:SetParent( optionsPanel );
	lbl_outline_alphaval:SetText (tostring(sct_cfg.outline_alpha) );
	table.insert (sct_opt, lbl_outline_alphaval);
	
	local sld_outline_alpha = Turbine.UI.Lotro.ScrollBar();
	sld_outline_alpha:SetSize( 100, 10 );
	sld_outline_alpha:SetPosition( 110, rows[row] );	
	sld_outline_alpha:SetParent( optionsPanel );	
	sld_outline_alpha:SetMinimum( 0 );	
	sld_outline_alpha:SetMaximum( 100 );	
	sld_outline_alpha:SetSmallChange ( 1 );
	sld_outline_alpha:SetValue ( sct_cfg.outline_alpha );
	sld_outline_alpha:SetOrientation (Turbine.UI.Orientation.Horizontal);
	sld_outline_alpha.ValueChanged = function()
		sct_cfg.outline_alpha = round (sld_outline_alpha:GetValue());
		lbl_outline_alphaval:SetText (tostring(sct_cfg.outline_alpha));
	end		
	table.insert (sct_opt, sld_outline_alpha);
	
	row = row+1;
-- Flags
		
	-- fade
	local chk_fade = Turbine.UI.Lotro.CheckBox();
	chk_fade:SetSize ( 80, 16);
	chk_fade:SetPosition( 12, rows[row] );		
	chk_fade:SetParent( optionsPanel );	
	chk_fade:SetText (" "..L["Fade"]);
	chk_fade:SetChecked( sct_cfg.fade);
	chk_fade.CheckedChanged = function ()
		sct_cfg.fade = chk_fade:IsChecked();
	end
	table.insert (sct_opt, chk_fade);
	
	-- outline
	local chk_outline = Turbine.UI.Lotro.CheckBox();
	chk_outline:SetSize ( 80, 16);
	chk_outline:SetPosition( 92, rows[row] );		
	chk_outline:SetParent( optionsPanel );	
	chk_outline:SetText (" "..L["Outline"]);
	chk_outline:SetChecked( sct_cfg.outline);
	chk_outline.CheckedChanged = function ()
		sct_cfg.outline = chk_outline:IsChecked();
	end 
	table.insert (sct_opt, chk_outline);
	
	-- zoom
	local chk_zoom = Turbine.UI.Lotro.CheckBox();
	chk_zoom:SetSize ( 80, 16);
	chk_zoom:SetPosition( 172, rows[row] );		
	chk_zoom:SetParent( optionsPanel );	
	chk_zoom:SetText (" "..L["Zoom"]);
	chk_zoom:SetChecked( sct_cfg.zoom);
	chk_zoom.CheckedChanged = function ()
		sct_cfg.zoom = chk_zoom:IsChecked();
	end	
	table.insert (sct_opt, chk_zoom);
	
	row = row+1;	
-- Buttons

	local btn_Save = Turbine.UI.Lotro.Button();
	btn_Save:SetText( L["Save"] );
	btn_Save:SetSize( 80, 22 );
	btn_Save:SetPosition( 10, rows[row] );
	btn_Save:SetParent( optionsPanel );
	btn_Save.Click = function( sender, args )
		Settings_Save();
	end
	table.insert (sct_opt, btn_Save);

	local btn_Defaults = Turbine.UI.Lotro.Button();
	btn_Defaults:SetText( L["Defaults"] );
	btn_Defaults:SetSize( 80, 22 );
	btn_Defaults:SetPosition( 90, rows[row] );
	btn_Defaults:SetParent( optionsPanel );
	btn_Defaults.Click = function( sender, args )
		Settings_Defaults();
	end
	table.insert (sct_opt, btn_Defaults);


end

-- clears all Controls
function _G.Settings_ClearPanel()
	--Turbine.Shell.WriteLine ("num sct_opt: ".. #sct_opt);
	if (#sct_opt >0) then
	
		for i=1,#sct_opt, 1 do
			sct_opt[i]:SetParent( nil);
		end

	end 	
		_G.sct_opt = {};
end


-- Set Default Settings
function _G.Settings_Defaults()
	_G.sct_cfg = {};
	
	sct_cfg.version = tostring(version);
-- dmgn 
	-- color
	sct_cfg.col_dmgn_r = 255;
	sct_cfg.col_dmgn_g = 255;
	sct_cfg.col_dmgn_b = 0;
	--flags
	sct_cfg.dir_dmgn = 1;
	
-- dmgc 
	-- color
	sct_cfg.col_dmgc_r = 167;
	sct_cfg.col_dmgc_g = 50;
	sct_cfg.col_dmgc_b = 167;
	--flags
	sct_cfg.dir_dmgc = 1;
	
-- dmgd
	-- color
	sct_cfg.col_dmgd_r = 255;
	sct_cfg.col_dmgd_g = 67;
	sct_cfg.col_dmgd_b = 167;
	--flags
	sct_cfg.dir_dmgd = 1;
	
-- heal 
	-- color
	sct_cfg.col_heal_r = 20;
	sct_cfg.col_heal_g = 255;
	sct_cfg.col_heal_b = 30;
	-- flags
	sct_cfg.dir_heal = 2;
	
-- power 
	-- color
	sct_cfg.col_powr_r = 30;
	sct_cfg.col_powr_g = 30;
	sct_cfg.col_powr_b = 255;	
	-- flags
	sct_cfg.dir_powr = 2;

-- power 
	-- color
	sct_cfg.col_takn_r = 255;
	sct_cfg.col_takn_g = 30;
	sct_cfg.col_takn_b = 30;	
	-- flags
	sct_cfg.dir_takn = 2;
		
-- general flags
	sct_cfg.fade = true;
	sct_cfg.outline = true;
	sct_cfg.zoom = false;
	sct_cfg.speed = 9;

-- margins	
	sct_cfg.margin_mid = 30;
	sct_cfg.margin_top = 100;
	sct_cfg.margin_bottom = 200;
	
-- x
	sct_cfg.center = 500;	-- 500 = middle
	
-- fontsize
	sct_cfg.fontsize = 10;

-- style outline
	sct_cfg.outline_alpha = 30;
	
	-- reload Settings
	Settings_ClearPanel();	
	Options();
	Turbine.Shell.WriteLine(L["Defaults_loaded"]);

end